<?php

namespace Drupal\mcapi\Entity\ListBuilder;

use Drupal\Core\Entity\EntityInterface;
use Drupal\Core\Entity\EntityListBuilder;
use Drupal\Core\Render\Markup;
use Drupal\mcapi\Entity\Workflow;

/**
 * Defines a class to build a listing of Workflow config entities.
 *
 */
class WorkflowListBuilder extends EntityListBuilder {

  /**
   * {@inheritDoc}
   */
  public function buildHeader() {
    // Enable language column and filter if multiple languages are added.
    $header = [
      'name' => [
        'data' => $this->t('Name'),
      ],
      'summary' => $this->t('Summary')
    ];
    return $header + parent::buildHeader();
  }

  /**
   * {@inheritDoc}
   */
  public function buildRow(EntityInterface $entity) {
    $row['name']['data'] = [
      '#markup' => Markup::Create($entity->label())
    ];
    $row['summary']['data'] = [
      '#markup' => Markup::Create($entity->summary)
    ];
    $row += parent::buildRow($entity);
    return $row;
  }


  protected function getTitle() {
    return $this->t('Workflows');
  }

  /**
   * {@inheritdoc}
   */
  public function load() {
    return Workflow::loadAlphabetical(TRUE);
  }
}
