<?php

namespace Drupal\mcapi\Entity\RouteProvider;

use Drupal\Core\Entity\Routing\DefaultHtmlRouteProvider;
use Drupal\Core\Entity\EntityTypeInterface;
use Symfony\Component\Routing\Route;

/**
 * Provides routes for the transaction entity.
 */
class TransactionRouteProvider extends DefaultHtmlRouteProvider {

  /**
   * {@inheritdoc}
   * generate one route for each declared transaction form
   */
  public function getRoutes(EntityTypeInterface $entity_type) {
    $route_collection = parent::getRoutes($entity_type);

    foreach (mcapi_mcapi_form_list() as $default_transaction_form) {
      $wf_id = $default_transaction_form['workflow'];
      $route = new Route('/transact/'.$wf_id);
      $route_collection->add(
        $default_transaction_form['route_name'],
        $route->setDefaults([
          '_entity_form' => 'mc_transaction.default',
          'mc_workflow' => $wf_id
        ])->setRequirement('_mc_transaction_create_access', 'true')
      );
    }
    return $route_collection;
  }

}
