<?php

namespace Drupal\mcapi\Plugin\Field;

use Drupal\Core\Field\FieldItemList;

/**
 * Entries field list
 */
class EntryFieldItemList extends FieldItemList {

  /**
   * {@inheritDoc}
   * Ensure the first Entry is primary
   */
  public function setValue($values, $notify = TRUE) {
    if ($this->count() == 0) {
      if (isset($values['payee_wid'])) {
        $values['primary'] = TRUE;
      }
      elseif(isset($values[0]['payee_wid'])) {
        $values[0]['primary'] = TRUE;
      }
    }
    // The mass transaction form uses the entity reference widget which returns a
    // values with a key of target_id for each FieldItem. Convert these to field
    // properties.
    foreach ($values as &$entry) {
      if (isset($entry['payee_wid']['target_id'])) {
        $entry['payee_wid'] = $entry['payee_wid']['target_id'];
      }
      elseif(isset($entry['payer_wid']['target_id'])) {
        $entry['payer_wid'] = $entry['payer_wid']['target_id'];
      }
    }
    parent::setValue($values, $notify);
  }

}
